freeslot(
	"S_DMPETAL",
	"MT_DMPETAL",
	"sfx_dmjump",
	"sfx_dmthok"
)

states[S_DMPETAL] = {
	sprite = SPR_HOOP,
	frame = A,
	tics = -1
}

mobjinfo[MT_DMPETAL] = {
	spawnstate = S_DMPETAL,
	flags = MF_SCENERY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOGRAVITY
}

local inPetalList = function(arr,mo)
	if #arr != 8 return false end
	
	for i = 1,8
		if arr[i] == mo return true end
	end
	
	return false
end

local all8petals = function(arr)
	if #arr != 8 return false end
	for i = 1,8
		if not (arr[i] and arr[i].valid)
			return false end
	end
	
	return true
end

// Air Acceleration by romoney1
local doAirAccel = function(player,mo)
	if player.aadisable player.aadisable = $-1 return end --you can set aadisable to 1 or 2 each tic for a custom character within your lua, in order to disable it
	if P_IsObjectOnGround(mo) or (mo.eflags & MFE_JUSTHITFLOOR) or player.powers[pw_tailsfly] or (mo.flags2 & MF2_TWOD) or (maptol & TOL_2D) or FRACUNIT == 0 return end
	if player.exiting or (player.pflags & PF_STASIS) or player.powers[pw_nocontrol] or P_PlayerInPain(player) or player.playerstate ~= PST_LIVE or not (mo.momx or mo.momy) return end
	if mo.skin == "mario" or mo.skin == "luigi" or mo.skin == "s3sonic" or (mo.skin == "cdsonic" and player.physics) or mo.skin == "elfilin" return end --if you're adding aa to a character, you can remove this line
	
	--P_3dMovement from p_user.c translated into lua
	local super = ((player.powers[pw_super] or player.powers[pw_sneakers]) and 2 or 1)
	local acceleration = player.accelstart/super + FixedDiv(player.speed,mo.scale)/FU * player.acceleration/super
	
	local normalspd = FixedMul(player.normalspeed,mo.scale)
	local topspeed = (player.powers[pw_super] or player.powers[pw_sneakers]) and 5*normalspd/3 or normalspd
	if (mo.eflags & (MFE_UNDERWATER|MFE_GOOWATER))
		topspeed = $ >> 1
		acceleration = $*2/3
	end
	
	local shift = (player.pflags & (PF_SPINNING|PF_THOKKED)) == PF_SPINNING and 3 or 2
	local om = R_PointToDist2(mo.momx,mo.momy,0,0) --old magnitude
	
	P_Thrust(mo,R_PointToAngle2(0,0,player.cmd.forwardmove*FU,-player.cmd.sidemove*FU) + (player.cmd.angleturn * FU),
	 	FixedMul((abs(player.cmd.forwardmove)+abs(player.cmd.sidemove))*(player.thrustfactor*super*acceleration),mo.scale) >> shift)
	
	local nm = R_PointToDist2(mo.momx,mo.momy,0,0) --new magnitude
	if nm > topspeed
		if om > topspeed and nm > om
			mo.momx, mo.momy = fixmul(fixdiv($1, nm), om), fixmul(fixdiv($2, nm), om)
		elseif om <= topspeed
			mo.momx, mo.momy = fixmul(fixdiv($1, nm), topspeed), fixmul(fixdiv($2, nm), topspeed)
		end
	end
end

addHook("PlayerThink",function(p)
	local mo = p.mo
	if not mo and mo.valid and mo.skin == "darkmatter" return end
	
	if not P_IsObjectOnGround(mo)
		mo.momz = $ + P_GetMobjGravity(mo)/-2,true
	end
	
	if not (p.petals
	and all8petals(p.petals))
		p.petals = {}
		for i = 1,8
			p.petals[i] = P_SpawnMobj(mo.x,mo.y,mo.z,MT_DMPETAL)
			local petal = p.petals[i]
			petal.angle = i * ANGLE_45
			petal.target = mo
		end
	end
	
	if not p.petalanim
		p.petalanim = ANGLE_45
	end
	
	if p.petalretract == nil
		p.petalretract = FU
	elseif p.playerstate != PST_LIVE
		p.petalretract = 0
	elseif p.dmcharge
		p.petalretract = max(0,$-FU/3)
		p.powers[pw_strong] = STR_ATTACK|STR_BUST|STR_SPIKE|STR_HEAVY
		p.drawangle = R_PointToAngle2(0,0,mo.momx,mo.momy)
	else
		p.petalretract = min(FU,$+FU/5)
		p.powers[pw_strong] = STR_NONE
	end
	
	if not p.squish
		p.squish = 0
	end
	
	if p.squishAnim != nil
		if p.dmcharge
			mo.spriteyoffset = 0
			p.squish = 0
			p.squishAnim = 0
		elseif P_PlayerInPain(p)
			p.squishAnim = $ + ANGLE_45
			p.squish = sin(p.squishAnim) / 4
			mo.spriteyoffset = 0
		elseif P_PlayerShouldUseSpinHeight(p)
			p.squish = FU/3
			mo.spriteyoffset = 0
			p.squishAnim = 0
		elseif P_IsObjectOnGround(mo)
			p.squishAnim = $ + ANG1
			p.squish = sin(p.squishAnim * 10) / 10
			mo.spriteyoffset = 4*FU + sin(p.squishAnim * 10) + (sin(p.squishAnim*3)*4)
		else
			p.squishanim = 0
			p.squish = max(min(mo.momz/20,FU/4),-FU/4)
			mo.spriteyoffset = 0
		end
	else
		p.squishAnim = 0
	end
	
	mo.spritexscale = FU+p.squish
	mo.spriteyscale = FU-p.squish
	
	doAirAccel(p,mo)
end)

addHook("JumpSpinSpecial",function(p)
	if not (p.dmcharge
	or p.exiting
	or p.powers[pw_nocontrol]
	or p.playerstate != PST_LIVE
	or p.lastspin)
		local mo = p.mo
		p.dmcharge = true
		S_StartSound(mo,sfx_dmthok)
		
		if p.cmd.buttons & BT_JUMP
			P_InstaThrust(mo,mo.angle,48*FU)
			mo.momz = 0
		else
			P_SetObjectMomZ(mo,-30*FU,true)
		end
	end
end)

addHook("PostThinkFrame",function()
	for p in players.iterate
		local mo = p.mo
		if not (mo and mo.valid and mo.skin == "darkmatter") continue end
		
		p.lastspin = p.cmd.buttons & BT_SPIN
		
		if not p.petals continue end
		
		local height = FixedMul(P_GetPlayerHeight(p),mo.spriteyscale)/2
		local radius = FixedMul(mo.radius,mo.spritexscale)
		
		for i = 1,8
			local petal = p.petals[i]
			local veca = {x = 0, y = 0, z = 0}
			local vecb = {x = 0, y = 0, z = 0}
			
			veca.x = $ + FixedMul(FixedMul(radius,cos(petal.angle)),cos(p.drawangle+ANGLE_90))
			veca.y = $ + FixedMul(FixedMul(radius,cos(petal.angle)),sin(p.drawangle+ANGLE_90))
			veca.z = $ + FixedMul(height,sin(petal.angle))
			
			veca.x = FixedMul($,cos(p.petalanim))
			veca.y = FixedMul($,cos(p.petalanim))
			veca.z = FixedMul($,cos(p.petalanim))
			
			vecb.x = $ + P_ReturnThrustX(mo,p.drawangle,-mo.radius)
			vecb.y = $ + P_ReturnThrustY(mo,p.drawangle,-mo.radius)
			
			vecb.x = FixedMul($,sin(p.petalanim))
			vecb.y = FixedMul($,sin(p.petalanim))
			vecb.z = FixedMul($,sin(p.petalanim))
			
			local vec = {x = veca.x + vecb.x, y = veca.y + vecb.y, z = veca.z + vecb.z}
			
			vec.x = FixedMul($,p.petalretract)
			vec.y = FixedMul($,p.petalretract)
			vec.z = FixedMul($,p.petalretract)
			
			vec.z = $ + mo.spriteyoffset + height
			
			if mo.eflags & MFE_VERTICALFLIP
				vec.z = -$ + mo.height
			end
			
			P_MoveOrigin(petal,mo.x + vec.x,mo.y + vec.y,mo.z + vec.z)
			
			petal.eflags = mo.eflags
			petal.flags2 = mo.flags2
			petal.renderflags = mo.renderflags
			petal.colorized = mo.colorized
			petal.color = mo.color
			
			petal.dispoffset = -i
		end
	end
end)

addHook("PreThinkFrame",function()
	for p in players.iterate
		local mo = p.mo
		if not (mo and mo.valid and mo.skin == "darkmatter") continue end
		
		if P_IsObjectOnGround(mo)
		or P_PlayerInPain(p)
		or p.powers[pw_carry]
		or ~p.pflags & PF_JUMPED
			p.dmcharge = false
		elseif p.dmcharge
			p.powers[pw_nocontrol] = 2
		end
	end
end)

addHook("MobjThinker",function(mo)
	if not (mo.target and mo.target.valid and mo.target.player
	and inPetalList(mo.target.player.petals,mo))
		mo.state = MT_NULL
	end
end, MT_DMPETAL)

addHook("MobjDamage",function(t,i,s)
	if s and s.player and s.skin == "darkmatter" s.player.dmcharge = false end
end)